# ej2-circulargauge

The circular gauge control is ideal to visualize numeric values over a circular scale. All the circular gauge elements are rendered using Scalable Vector Graphics (SVG).

![Circular Gauge](https://ej2.syncfusion.com/products/images/circulargauge/readme.gif)

> Circular gauge is part of Syncfusion Essential JS 2 commercial program. License is available in two models Community and Paid. Please refer the license file for more information. License can be obtained by registering at [https://www.syncfusion.com/downloads/essential-js2](https://www.syncfusion.com/downloads/essential-js2?utm_source=npm&utm_campaign=circulargauge)

## Setup

To install circular gauge and its dependent packages, use the following command

```sh
npm install @syncfusion/ej2-circulargauge
```

## Resources

* [Getting Started](https://ej2.syncfusion.com/documentation/circular-gauge/getting-started.html?lang=typescript)
* [View Online Demos](https://ej2.syncfusion.com/demos/?utm_source=npm&utm_campaign=circulargauge#/material/circulargauge/default.html)
* [Product Page](https://www.syncfusion.com/products/javascript/circulargauge)

## Supported Frameworks

Circular gauge component is also offered in following list of frameworks.

1. [Angular](https://www.npmjs.com/package/@syncfusion/ej2-ng-circulargauge?utm_source=npm&utm_campaign=circulargauge)
2. [React](https://www.npmjs.com/package/@syncfusion/ej2-react-circulargauge?utm_source=npm&utm_campaign=circulargauge)
3. [Vue.js](https://www.npmjs.com/package/@syncfusion/ej2-vue-circulargauge?utm_source=npm&utm_campaign=circulargauge)
4. [ASP.NET Core](https://aspdotnetcore.syncfusion.com/CircularGauge/Default#/material)
5. [ASP.NET MVC](https://aspnetmvc.syncfusion.com/CircularGauge/DefaultFunctionalities#/material)
6. [JavaScript (ES5)](https://www.syncfusion.com/products/javascript/circulargauge)

## Use case samples

* Live update ([Live Demo](https://ej2.syncfusion.com/demos/?utm_source=npm&utm_campaign=circulargauge#/material/circulargauge/datasample.html))
* Direction compass ([Live Demo](https://ej2.syncfusion.com/demos/?utm_source=npm&utm_campaign=circulargauge#/material/circulargauge/compass.html))

## Key Features

* [**Axes**](https://ej2.syncfusion.com/demos/?utm_source=npm&utm_campaign=circulargauge#/material/circulargauge/axes.html) - Axes is a collection of circular axis that can be used to indicate numeric values.
* [**Ranges**](https://ej2.syncfusion.com/demos/?utm_source=npm&utm_campaign=circulargauge#/material/circulargauge/ranges.html) - Supports ranges to categorize the axis values. Any number of ranges can be added to the circular gauge.
* [**Ticks and Labels**](https://ej2.syncfusion.com/demos/?utm_source=npm&utm_campaign=circulargauge#/material/circulargauge/ranges.html) - Provides options to customize the ticks and labels of the gauges.
* [**Pointers**](https://ej2.syncfusion.com/demos/?utm_source=npm&utm_campaign=circulargauge#/material/circulargauge/axes.html) - Indicates the values on axis. Circular gauge supports three types of pointers: needle, range bar, and marker.
* [**Annotation**](https://ej2.syncfusion.com/demos/?utm_source=npm&utm_campaign=circulargauge#/material/circulargauge/annotation.html) - Uses any custom HTML element as annotation and place it anywhere on the gauge.
* [**Tooltip**](https://ej2.syncfusion.com/demos/?utm_source=npm&utm_campaign=circulargauge#/material/circulargauge/tooltip.html) - Provides information about the pointer values on mouse hover.
* [**Pointer Drag**](https://ej2.syncfusion.com/demos/?utm_source=npm&utm_campaign=circulargauge#/material/circulargauge/user-interaction.html) - Provides support to place a pointer at the desired values by dragging it. 

## Support

Product support is available for through following mediums.

* Creating incident in Syncfusion [Direct-trac](https://www.syncfusion.com/support/directtrac/incidents?utm_source=npm&utm_campaign=circulargauge) support system or [Community forum](https://www.syncfusion.com/forums/essential-js2?utm_source=npm&utm_campaign=circulargauge).
* New [GitHub issues](https://github.com/syncfusion/ej2-javascript-ui-controls/issues).
* Ask your query in Stack Overflow with tag `syncfusion`, `ej2`.

## License

Check the license detail [here](https://github.com/syncfusion/ej2-javascript-ui-controls/blob/master/license?utm_source=npm&utm_campaign=circulargauge).

## Changelog

Check the changelog [here]https://github.com/syncfusion/ej2-javascript-ui-controls/blob/master/controls/circulargauge/CHANGELOG.md?utm_source=npm&utm_campaign=circulargauge)

© Copyright 2019 Syncfusion, Inc. All Rights Reserved. The Syncfusion Essential Studio license and copyright applies to this distribution.