# ej2-documenteditor

The Document Editor component is used to create, edit, view, and print Word documents in web applications. All the user interactions and editing operations that run purely in the client-side provides much faster editing experience to the users.

![Document Editor](https://ej2.syncfusion.com/products/images/documenteditor/readme.gif)

> This is a commercial product and requires a paid license for possession or use. Syncfusion’s licensed software, including this component, is subject to the terms and conditions of Syncfusion's EULA (https://www.syncfusion.com/eula/es/). To acquire a license, you can purchase one at https://www.syncfusion.com/sales/products or start a free 30-day trial here (https://www.syncfusion.com/account/manage-trials/start-trials).

> A free community license (https://www.syncfusion.com/products/communitylicense) is also available for companies and individuals whose organizations have less than $1 million USD in annual gross revenue and five or fewer developers.


## Setup

To install Document Editor and its dependent packages, use the following command

```sh
npm install @syncfusion/ej2-documenteditor
```

## Resources

* [Getting Started](https://ej2.syncfusion.com/documentation/document-editor/getting-started?lang=typescript&utm_source=npm&utm_campaign=documenteditor)
* [View Online Demos](https://ej2.syncfusion.com/demos/#/material/document-editor/default.html?utm_source=npm&utm_campaign=documenteditor)
* [Product Page](https://www.syncfusion.com/javascript-ui-controls/document-editor?utm_source=npm&utm_campaign=documenteditor)

## Supported Frameworks

Document Editor component is also offered in following list of frameworks.

1. [Angular](https://www.syncfusion.com/angular-ui-components/document-editor?utm_source=npm&utm_campaign=documenteditor)
2. [React](https://www.syncfusion.com/react-ui-components/document-editor?utm_source=npm&utm_campaign=documenteditor)
3. [VueJS](https://www.syncfusion.com/vue-ui-components/document-editor?utm_source=npm&utm_campaign=documenteditor)
4. [ASP.NET Core](https://www.syncfusion.com/aspnet-core-ui-controls/document-editor?utm_source=npm&utm_campaign=documenteditor)
5. [ASP.NET MVC](https://www.syncfusion.com/aspnet-mvc-ui-controls/document-editor?utm_source=npm&utm_campaign=documenteditor)
6. [JavaScript (ES5)](https://www.syncfusion.com/javascript-ui-controls/document-editor?utm_source=npm&utm_campaign=documenteditor)

## Key Features

* [**Document Authoring**](https://ej2.syncfusion.com/demos/document-editor/default/index.html?utm_source=npm&utm_campaign=documenteditor#fabric) -  Allows to create a document with supported elements and formatting options.
  * **Supported elements** - Supports document elements like text, inline image, table, hyperlink, fields, bookmark, table of contents, section, header, and footer.
  * **Styles** - Supports character and paragraph styles.
  * **Editing** - Supports all the common editing and formatting operations.
  * **History** - Supports options to perform undo redo operations.
  * **Find and replace** - Provides support to find and replace text within the document.
* **Export** - Provides the options to export the documents in the client-side as `Syncfusion Document Text (*.sfdt)` and `Word document (*.docx)`.
* **Import** - Provides the options to import the native `Syncfusion Document Text (*.sfdt)` format documents in the client-side.
* **Print** - Provides the options to print the documents.
* **Clipboard** - Provides support to cut, copy, and paste rich text contents within the component. Also allows pasting simple text from other applications.
* **User interface** - Provides intuitive user friendly interface to perform various operations.
  * **Context menu** - Provides context menu.
  * **Dialog** - Provides dialog for inserting elements such as hyperlink, table and formatting such as font, paragraph, list, style, table.
  * **Options pane** - Provides options pane to perform find and replace operations.

## Support

Product support is available for through following mediums.

* Creating incident in Syncfusion [Direct-trac](https://www.syncfusion.com/support/directtrac/incidents?utm_source=npm&utm_campaign=documenteditor) support system or [Community forum](https://www.syncfusion.com/forums/essential-js2?utm_source=npm&utm_campaign=documenteditor).
* New [GitHub issue](https://github.com/syncfusion/ej2-javascript-ui-controls/issues/new?utm_source=npm&utm_campaign=documenteditor).
* Ask your query in Stack Overflow with tag `syncfusion`, `ej2`.

## License

Check the license detail [here](https://github.com/syncfusion/ej2-javascript-ui-controls/blob/master/license?utm_source=npm&utm_campaign=documenteditor).

## Changelog

Check the changelog [here](https://github.com/syncfusion/ej2-javascript-ui-controls/blob/master/controls/documenteditor/CHANGELOG.md?utm_source=npm&utm_campaign=documenteditor)


© Copyright 2019 Syncfusion, Inc. All Rights Reserved. The Syncfusion Essential Studio license and copyright applies to this distribution.
