import { Column } from './../models/column';
import { Row } from './../models/row';
import { IGrid } from '../base/interface';
import { Query } from '@syncfusion/ej2-data';
import { Data } from '../actions/data';
import { Grid } from '../base/grid';
/**
 * @hidden
 * `ExportHelper` for `PdfExport` & `ExcelExport`
 */
export declare class ExportHelper {
    parent: IGrid;
    private colDepth;
    private hideColumnInclude;
    private foreignKeyData;
    constructor(parent: IGrid);
    static getQuery(parent: IGrid, data: Data): Query;
    getFData(value: string, column: Column): Object;
    getGridRowModel(columns: Column[], dataSource: Object[], gObj: IGrid, startIndex?: number): Row<Column>[];
    private generateCells;
    getColumnData(gridObj: Grid): Promise<Object>;
    getHeaders(columns: Column[], isHideColumnInclude?: boolean): {
        rows: Row<Column>[];
        columns: Column[];
    };
    getConvertedWidth(input: string): number;
    private generateActualColumns;
    private processHeaderCells;
    private appendGridCells;
    private generateCell;
    private processColumns;
    private getCellCount;
    checkAndExport(gridPool: Object, globalResolve: Function): void;
    failureHandler(gridPool: Object, childGridObj: IGrid, resolve: Function): Function;
    createChildGrid(gObj: IGrid, row: any, exportType: string, gridPool: Object): {
        childGrid: IGrid;
        element: HTMLElement;
    };
}
/**
 * @hidden
 * `ExportValueFormatter` for `PdfExport` & `ExcelExport`
 */
export declare class ExportValueFormatter {
    private internationalization;
    private valueFormatter;
    constructor(culture: string);
    private returnFormattedValue;
    formatCellValue(args: any): string;
}
