import { Maps } from '../../maps/maps';
import { Point } from '../utils/helper';
import { LayerSettings, Tile } from '../model/base';
import { BingMap } from './bing-map';
/**
 * To calculate and render the shape layer
 */
export declare class LayerPanel {
    private mapObject;
    private currentFactor;
    private groupElements;
    private layerObject;
    private currentLayer;
    private rectBounds;
    tiles: Tile[];
    private clipRectElement;
    private layerGroup;
    private tileTranslatePoint;
    private urlTemplate;
    private isMapCoordinates;
    private exactBounds;
    private tileSvgObject;
    private ajaxModule;
    private ajaxProcessCount;
    private ajaxResponse;
    private bing;
    constructor(map: Maps);
    measureLayerPanel(): void;
    protected renderTileLayer(panel: LayerPanel, layer: LayerSettings, layerIndex: number, bing?: BingMap): void;
    protected processLayers(layer: LayerSettings, layerIndex: number): void;
    private bubbleCalculation;
    calculatePathCollection(layerIndex: number, renderData: Object[]): void;
    /**
     *  render datalabel
     */
    private renderLabel;
    /**
     * To render path for multipolygon
     */
    private generateMultiPolygonPath;
    /**
     * To render bubble
     */
    private renderBubble;
    /**
     * To get the shape color from color mapping module
     */
    private getShapeColorMapping;
    generatePoints(type: string, coordinates: Object[], data: Object, properties: Object): void;
    calculateFactor(layer: LayerSettings): number;
    translateLayerElements(layerElement: Element, index: number): void;
    calculateRectBounds(layerData: Object[]): void;
    calculatePolygonBox(coordinates: Object[], data: Object, properties: Object): Object;
    calculateRectBox(coordinates: Object[]): void;
    generateTiles(zoomLevel: number, tileTranslatePoint: Point, bing?: BingMap): void;
    arrangeTiles(): void;
    private templateCompiler;
    private panTileMap;
}
