### Bug description

Clearly and concisely describe the problem or feature (this cannot be empty).

### Root cause

Briefly describe the root cause and analysis of the problem.
If there is an internal discussion on the forum, provide the link.

### Reason for not identifying earlier

Find how it was missed in our earlier testing and development by analysing the below checklist. This will help prevent similar mistakes in the future. 

 - [ ] Guidelines/documents are not followed

    - Common guidelines / Core team guideline
    - Specification document
    - Requirement document

 - [ ] Guidelines/documents are not given


    - Common guidelines / Core team guideline
    - Specification document
    - Requirement document


### Reason:

Mention any one or more reasons from the above points.

### Action taken:

What action did you take to avoid this in future?

### Related areas:

Is there any other related areas also to be addressed?

### Is it a breaking issue?

If it is a breaking issue, provide the commit detail which caused this break.

### Solution description

Describe your code changes in detail for reviewers.

### Output screenshots

Post the output screenshots if an UI is affected or added due to this bug.

### Areas affected and ensured

List the areas affected by your code changes.

```md
Note: Ensure this from feature matrix
```
[Feature Matrix](https://syncfusion.atlassian.net/wiki/spaces/BI/pages/1151566023/EJ2+Pivot+Table+-+Feature+matrix)

### Additional checklist

```md
Note: Don’t delete the template here. If they are not applicable keep them unchecked
```
* [ ] Code doesn’t have memory leak. 
* [ ] Have you added or updated API comments if it is new API or behavior change?
* [ ] Localization aspect ensured?
* [ ] Globalization aspect ensured. Ensure culture based testing?
* [ ] If changes are made in theme file, did you updated all themes.
* [ ] Feature matrix 
* [ ] Web accessibility 
* [ ] Responsive with different devices
* [ ] Touch support, Keyboard
* [ ] RTL
* [ ] Cross browsers[Chrome, Firefox, IE, Opera, Safari]
