# ej2-pivotview

The pivot grid is a multi-dimensional data visualization component built on top of the relational data sources. The pivot report can be managed dynamically at runtime along with other capabilities like aggregation, filtering and sorting (field and value based).

![Pivot Grid](https://ej2.syncfusion.com/products/typescript/pivotview/readme.gif)

>Note: This is a commercial product and requires a paid license for possession or use. Syncfusion’s licensed software, including this component, is subject to the terms and conditions of Syncfusion's [EULA](https://www.syncfusion.com/eula/es/). To acquire a license, you can purchase one at https://www.syncfusion.com/sales/products or start a free 30-day trial [here](https://www.syncfusion.com/account/manage-trials/start-trials).
>A free community [license](https://www.syncfusion.com/products/communitylicense) is also available for companies and individuals whose organizations have less than $1 million USD in annual gross revenue and five or fewer developers..

## Setup

To install Pivot Grid and its dependent packages, use the following command.

```sh
npm install @syncfusion/ej2-pivotview
```

## Resources

* [Getting Started](https://ej2.syncfusion.com/documentation/pivotview/getting-started.html?lang=typescript&utm_source=npm&utm_campaign=pivot-grid)
* [View Online Demos](https://ej2.syncfusion.com/demos/?utm_source=npm&utm_campaign=pivot-grid#/material/pivot-view/default.html)
* [Product Page](https://www.syncfusion.com/javascript-ui-controls/pivot-table)

## Supported Frameworks

Pivot Grid component is also offered in following list of frameworks.

1. [Angular](https://www.syncfusion.com/angular-ui-components/pivot-table)
2. [React](https://www.syncfusion.com/react-ui-components/pivot-table)
3. [VueJS](https://www.syncfusion.com/vue-ui-components/pivot-table)
4. [ASP.NET Core](https://www.syncfusion.com/aspnet-core-ui-controls/pivot-table)
5. [ASP.NET MVC](https://www.syncfusion.com/aspnet-mvc-ui-controls/pivot-table)
6. [JavaScript (ES5)](https://www.syncfusion.com/javascript-ui-controls/pivot-table)

## Key Features

* [**Data Sources**](https://ej2.syncfusion.com/demos/?utm_source=npm&utm_campaign=pivot-grid#/material/pivot-view/local.html) - Binds the component with an array of JavaScript objects.
* [**Filtering**](https://ej2.syncfusion.com/demos/?utm_source=npm&utm_campaign=pivot-grid#/material/pivot-view/filtering.html) - Allows user to view only specific/desired records in the component.
* [**Sorting**](https://ej2.syncfusion.com/demos/?utm_source=npm&utm_campaign=pivot-grid#/material/pivot-view/sorting.html) - Both member and value sorting are supported. It’s allows user to order fields and values (column) either in ascending or descending order respectively.
* [**Field List & Grouping Bar**](https://ej2.syncfusion.com/demos/?utm_source=npm&utm_campaign=pivot-grid#/material/pivot-view/grouping-bar.html) - Supports UI interaction at runtime to dynamically change the report along with sorting, filtering and remove options.
* [**Aggregation**](https://ej2.syncfusion.com/demos/?utm_source=npm&utm_campaign=pivot-grid#/material/pivot-view/aggregation.html) - Provides built in aggregation types like sum, average, min, max and count.
* [**Calculated Field**](https://ej2.syncfusion.com/demos/?utm_source=npm&utm_campaign=pivot-grid#/material/pivot-view/calculated-field.html) - Users can add new value field(s) to the report dynamically using this option.
* **Adaptive Rendering** - Adapts with optimal user interfaces for mobile and desktop form-factors, thus helping the user’s application to scale elegantly across all the form-factors without any additional effort.
* [**Exporting**](https://ej2.syncfusion.com/demos/?utm_source=npm&utm_campaign=pivot-grid#/material/pivot-view/exporting.html) - Provides the option to exporting records to Excel, CSV and PDF formats.

## Support

Product support is available for through following mediums.

* Creating incident in Syncfusion [Direct-trac](https://www.syncfusion.com/support/directtrac/incidents?utm_source=npm&utm_campaign=pivot-grid) support system or [Community forum](https://www.syncfusion.com/forums/essential-js2?utm_source=npm&utm_campaign=pivot-grid).
* New [GitHub issue](https://github.com/syncfusion/ej2-javascript-ui-controls/issues/new).
* Ask your query in Stack Overflow with tag `syncfusion`, `ej2`.

## License

Check the license detail [here](https://github.com/syncfusion/ej2-javascript-ui-controls/blob/master/license?utm_source=npm&utm_campaign=pivot-grid).

## Changelog

Check the changelog [here](https://github.com/syncfusion/ej2-javascript-ui-controls/blob/master/controls/pivotview/CHANGELOG.md?utm_source=npm&utm_campaign=pivot-grid)

&copy; Copyright 2019 Syncfusion, Inc. All Rights Reserved. The Syncfusion Essential Studio license and copyright applies to this distribution.