import { PivotEngine } from '../../base/engine';
import { PivotView } from '../base/pivotview';
import { ColumnModel } from '@syncfusion/ej2-grids';
import { GridSettingsModel } from '../model/gridsettings-model';
import { OlapEngine } from '../../base/olap/engine';
/**
 * Module to render PivotGrid control
 */
export declare class Render {
    parent: PivotView;
    engine: PivotEngine | OlapEngine;
    gridSettings: GridSettingsModel;
    rowStartPos: number;
    maxIndent: number;
    indentCollection: {
        [key: number]: number;
    };
    private formatList;
    private colPos;
    private lastSpan;
    private resColWidth;
    private aggMenu;
    private field;
    private fieldCaption;
    private lvlCollection;
    private hierarchyCollection;
    private lvlPosCollection;
    private hierarchyPosCollection;
    private position;
    private measurePos;
    private maxMeasurePos;
    private hierarchyCount;
    private actualText;
    private timeOutObj;
    /** Constructor for render module */
    constructor(parent: PivotView);
    render(): void;
    private refreshHeader;
    bindGrid(parent: PivotView, isEmpty: boolean): void;
    private headerRefreshed;
    private beforeExcelExport;
    private rowSelected;
    private rowDeselected;
    private cellSelected;
    private cellSelecting;
    private cellDeselected;
    private queryCellInfo;
    private headerCellInfo;
    private excelHeaderQueryCellInfo;
    private pdfQueryCellInfo;
    private excelQueryCellInfo;
    private pdfHeaderQueryCellInfo;
    private dataBound;
    private contextMenuOpen;
    private contextMenuClick;
    private updateAggregate;
    private injectGridModules;
    updateGridSettings(): void;
    private updatePivotColumns;
    private clearColumnSelection;
    private appendValueSortIcon;
    private onResizeStop;
    private setGroupWidth;
    selected(): void;
    private onSelect;
    private rowCellBoundEvent;
    private onOlapRowCellBoundEvent;
    private columnCellBoundEvent;
    private onOlapColumnCellBoundEvent;
    private isSpannedCell;
    private onHyperCellClick;
    private getRowStartPos;
    private frameDataSource;
    frameEmptyData(): any[];
    calculateColWidth(colCount: number): number;
    resizeColWidth(colCount: number): number;
    calculateGridWidth(): number | string;
    calculateGridHeight(elementCreated?: boolean): number | string;
    frameStackedHeaders(): ColumnModel[];
    setSavedWidth(column: string, width: number): number;
    frameEmptyColumns(): ColumnModel[];
    getFormatList(): {
        [key: string]: string;
    };
    private excelColumnEvent;
    private pdfColumnEvent;
    private excelRowEvent;
    private pdfRowEvent;
    private exportHeaderEvent;
    private exportContentEvent;
    private unWireEvents;
    private wireEvents;
}
