# ej2-schedule

The schedule component is an event calendar that facilitates almost all the basic Outlook and Google Calendar features, allowing the user to plan and manage appointments and time efficiently. It receives data from a variety of data sources, such as an array of JSON objects, OData web services, RESTful or WCF services, and [`DataManager`](https://ej2.syncfusion.com/documentation/data/?lang=typescript) with built-in load on demand support to reduce the data transfer and load time. Also, it is availed with the multiple resources support that allots an unique individual space for more than one resources on the same calendar.

![Schedule](https://ej2.syncfusion.com/products/images/schedule/readme.png)

> This is a commercial product and requires a paid license for possession or use. Syncfusion’s licensed software, including this component, is subject to the terms and conditions of Syncfusion's [EULA](https://www.syncfusion.com/eula/es/). To acquire a license, you can purchase one at [here](https://www.syncfusion.com/sales/products) or start a free 30-day trial from [here](https://www.syncfusion.com/account/manage-trials/start-trials).

> A free community [license](https://www.syncfusion.com/products/communitylicense) is also available for companies and individuals whose organizations have less than $1 million USD in annual gross revenue and five or fewer developers.

## Setup

To install Schedule and its dependent packages, use the following command.

```sh
npm install @syncfusion/ej2-schedule
```

## Resources

* [Getting Started](https://ej2.syncfusion.com/documentation/schedule/getting-started.html?lang=typescript)
* [View Online Demos](https://ej2.syncfusion.com/demos/#/material/schedule/default.html)
* [Product Page](https://www.syncfusion.com/javascript-ui-controls/scheduler)

## Supported Frameworks

Schedule component is also available in following list of frameworks.

1. [Angular](https://github.com/syncfusion/ej2-angular-ui-components)
2. [React](https://github.com/syncfusion/ej2-react-ui-components)
3. [VueJS](https://github.com/syncfusion/ej2-vue-ui-components)
4. [ASP.NET Core](https://www.syncfusion.com/aspnet-core-ui-controls/scheduler)
5. [ASP.NET MVC](https://www.syncfusion.com/aspnet-mvc-ui-controls/scheduler)

## Showcase samples

* Fare Calendar ([Live Demo](https://ej2.syncfusion.com/demos/#/material/schedule/resources.html))

## Key Features

* [**Views**](https://ej2.syncfusion.com/demos/#/material/schedule/views.html) - Schedule is now availed with 10 different view modes – day, week, work week, month, timeline day, timeline week, timeline work-week, timeline month, agenda and month agenda. It is possible to configure view-based settings on each view mode. The `Week` view is set as active view by default.
* [**Data binding**](https://ej2.syncfusion.com/demos/#/material/schedule/remote-data.html) - Seamless data binding with various client-side and remote data sources thus allowing the data to load on demand by default to reduce the data transfer and loading time.
* **Drag and drop** - Appointments can be easily rescheduled to another time by dragging and dropping them onto the required time slots.
* **Appointment resize** - An appointment’s time can be easily extended by resizing its start or end handlers.
* [**Multiple resources**](https://ej2.syncfusion.com/demos/#/material/schedule/resource-grouping.html) - Supports planning and management of events for multiple resources and allows to group them under appropriate resources. Also, supports date-wise grouping, linked appointments and other group related customizations.
* [**Recurrence**](https://ej2.syncfusion.com/demos/#/material/schedule/recurrence-events.html) - Allows the user to repeat a set of events on a daily, weekly, monthly, or yearly basis.
* [**Template**](https://ej2.syncfusion.com/demos/#/material/schedule/event-template.html) - The key elements like events, date header, work cells and event tooltip comes with the default template support which allows the flexible end-user customization to embed any kind of text, images, or styles to it.
* [**Timezone**](https://ej2.syncfusion.com/demos/#/material/schedule/timezone.html) -  Regardless of whatever time zone your system follows, Schedule supports setting your own required time zone value to it as well as to each event – thus allowing the events to display on its exact local time.
* [**Timescale**](https://ej2.syncfusion.com/demos/#/material/schedule/time-scale.html) - Allows to display customized time duration, with clear and accurate depiction of appointments across the appropriate time slots.
* [**Customizable working days and hours**](https://ej2.syncfusion.com/demos/#/material/schedule/work-days.html) - Users can set specific [work hour](https://ej2.syncfusion.com/demos/#/material/schedule/work-hour.html) range which is visually differentiated with active colour. Also, the working days collection can be customized with specific days, so that the remaining days will be considered as [weekend](https://ej2.syncfusion.com/demos/#/material/schedule/hide-weekend.html).
* [**Custom editor template**](https://ej2.syncfusion.com/demos/#/material/schedule/editor-template.html) - Template option is availed for event editor, thus allowing the users to add their own custom editor design and also provides option to add additional fields onto the default event editor.
* [**Adaptive rendering**](https://ej2.syncfusion.com/demos/#/material/schedule/month-agenda.html) - Adapts with optimal user interfaces for mobile and desktop form-factors, thus helping the user’s application to scale elegantly across all the form-factors without any additional effort.
* [**Keyboard interaction**](https://ej2.syncfusion.com/demos/#/material/schedule/keyboard-interaction.html) - All the common actions such as traversing through the appointments, multiple cell selection, add/edit/delete the appointments, navigate to other views, dates and much more can be performed through keyboard inputs.
* [**Localization**](https://ej2.syncfusion.com/documentation/schedule/localization.html?lang=typescript#localization) - All the static text and date content can be localized to any desired language. Also, it can be displayed with appropriate time mode and date-format as per the localized language.
* [**RTL**](https://ej2.syncfusion.com/documentation/schedule/localization.html?lang=typescript#rtl) - Supports displaying the component to display in the direction from right to left.

## Support

Product support is available through following mediums.

* Creating incident through Syncfusion [Direct-trac](https://www.syncfusion.com/support/directtrac/incidents) support system or [Community forum](https://www.syncfusion.com/forums/essential-js2).
* New [GitHub issue](https://github.com/syncfusion/ej2-javascript-ui-controls/issues/new).
* Ask your query in Stack Overflow with tag `syncfusion`, `ej2`.

## License

Check the license detail [here](https://github.com/syncfusion/ej2-javascript-ui-controls/blob/master/license).

## Changelog

Check the changelog [here](https://ej2.syncfusion.com/documentation/release-notes).

© Copyright 2019 Syncfusion, Inc. All Rights Reserved. The Syncfusion Essential Studio license and copyright applies to this distribution.