import { Schedule } from '../base/schedule';
import { ViewBase } from './view-base';
import { TdData, IRenderer, TimeSlotData } from '../base/interface';
/**
 * vertical view
 */
export declare class VerticalView extends ViewBase implements IRenderer {
    currentTimeIndicatorTimer: number;
    viewClass: string;
    isInverseTableSelect: boolean;
    baseCssClass: string;
    /**
     * Constructor for vertical view
     */
    constructor(parent: Schedule);
    addEventListener(): void;
    removeEventListener(): void;
    renderEvents(): void;
    private onContentScroll;
    private onApaptiveMove;
    private onApaptiveScroll;
    scrollLeftPanel(target: HTMLElement): void;
    private scrollUiUpdate;
    setContentHeight(element: HTMLElement, leftPanelElement: HTMLElement, height: number): void;
    scrollToWorkHour(): void;
    scrollToHour(hour: string): void;
    generateColumnLevels(): TdData[][];
    getDateSlots(renderDates: Date[], workDays: number[], workStartHour?: string, workEndHour?: string): TdData[];
    private isWorkHourRange;
    highlightCurrentTime(): void;
    getCurrentTimeIndicatorIndex(): number[];
    private clearCurrentTimeIndicatorTimer;
    removeCurrentTimeIndicatorElements(): void;
    changeCurrentTimePosition(): void;
    getTopFromDateTime(date: Date): number;
    private getWorkCellHeight;
    private getTdContent;
    renderLayout(type: string): void;
    renderHeader(): void;
    renderContent(): void;
    private renderLeftIndent;
    renderDatesHeader(): Element;
    createAllDayRow(table: Element, tdData: TdData[]): void;
    createTd(td: TdData): Element;
    private wireCellEvents;
    private wireMouseEvents;
    private renderTimeCells;
    renderContentArea(): Element;
    renderContentTable(table: Element): void;
    createContentTd(tdData: TdData, r: TimeSlotData, td: Element): Element;
    getContentTdClass(r: TimeSlotData): string[];
    private renderContentTableHeader;
    private createEventWrapper;
    getScrollableElement(): Element;
    getLeftPanelElement(): HTMLElement;
    getEndDateFromStartDate(start: Date): Date;
    getTimeSlotRows(handler?: Function): TimeSlotData[];
    /**
     * Get module name.
     */
    protected getModuleName(): string;
    /**
     * To destroy the vertical view.
     * @return {void}
     * @private
     */
    destroy(): void;
}
