import { Spreadsheet } from '../base/index';
/**
 * The `Scroll` module is used to handle scrolling behavior.
 * @hidden
 */
export declare class Scroll {
    private parent;
    private onScroll;
    private offset;
    private topIndex;
    private leftIndex;
    private initScrollValue;
    /** @hidden */
    prevScroll: {
        scrollLeft: number;
        scrollTop: number;
    };
    /**
     * Constructor for the Spreadsheet scroll module.
     * @private
     */
    constructor(parent: Spreadsheet);
    /**
     * For internal use only - Get the module name.
     * @private
     */
    protected getModuleName(): string;
    private onContentScroll;
    private updateNonVirtualRows;
    private updateNonVirtualCols;
    private updateTopLeftCell;
    private getRowOffset;
    private getColOffset;
    private wireEvents;
    private initProps;
    private getThreshold;
    /**
     * @hidden
     */
    setPadding(): void;
    private addEventListener;
    destroy(): void;
    private removeEventListener;
}
